package com.yihu.hos.server.controller;

import com.yihu.hos.server.service.ServerMetricsService;
import com.yihu.hos.web.framework.model.ActionResult;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.hyperic.sigar.SigarException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 *  服务器健康监控
 * @author HZY
 * @vsrsion 1.0
 * Created at 2016/10/14.
 */
@RestController("ServerMetricsController")
@RequestMapping("/serverMetrics")
public class ServerMetricsController {

    @Autowired
    private ServerMetricsService serverMetricsService;

    @RequestMapping(value = "/searchHistory", method = RequestMethod.GET)
    @ApiOperation(value = "获取服务器历史监控数据", response = ActionResult.class, produces = "application/json", notes = "获取服务器历史监控数据")
    public ActionResult getHistory(
            @ApiParam(name = "type", value = "类型")
            @RequestParam(value = "type") String type,
            @ApiParam(name = "beginTime", value = "开始时间")
            @RequestParam(value = "beginTime", required = false) String beginTime,
            @ApiParam(name = "endTime", value = "结束时间")
            @RequestParam(value = "endTime", required = false) String endTime) {

        try {
            JSONArray data  = serverMetricsService.getHistory(type, beginTime, endTime);
            ActionResult result = new ActionResult(true,"查询成功");
            result.setData(data);
            return result;
        } catch (Exception e) {
            e.printStackTrace();
        }
        ActionResult result = new ActionResult(false,"查询异常");
        return result;

    }


    @RequestMapping(value = "/searchCurrent", method = RequestMethod.GET)
    @ApiOperation(value = "获取服务器当前健康指标", response = ActionResult.class, produces = "application/json", notes = "获取服务器当前健康指标")
    public ActionResult searchCurrent(
            @ApiParam(name = "type", value = "类型")
            @RequestParam(value = "type") String type) {
        JSONObject data = null;
        try {
            data = serverMetricsService.getCurrent(type);
            ActionResult result = new ActionResult(true,"查询成功");
            result.setData(data);
            return result;
        } catch (SigarException e) {
            e.printStackTrace();
        }
        ActionResult result = new ActionResult(false,"查询异常");
        return result;

    }


    @RequestMapping(value = "/searchHardware", method = RequestMethod.GET)
    @ApiOperation(value = "获取服务器硬件信息", response = ActionResult.class, produces = "application/json", notes = "获取服务器硬件信息")
    public ActionResult searchHardware(
            @ApiParam(name = "type", value = "类型")
            @RequestParam(value = "type") String type) {
        //TODO 可以和上一個接口可共用
        return null;
    }



}


